<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  Faq,
  CropInfinityHero,
  NextStep,
} from '../components/common/index.vue';
import { SalesForm } from '../components/sales/index.vue';
import { CONTENT_TYPES } from '../common/content-types';
import { getClient } from '../plugins/contentful';
import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: {
    Faq,
    SalesForm,
    CropInfinityHero,
    NextStep,
  },
  async asyncData({ $content, error, i18n }: any) {
    try {
      const locale = i18n.locale === i18n.defaultLocale ? '' : i18n.locale;
      if (locale) {
        const sales = await $content(locale, 'sales').fetch();
        return { sales };
      }
      const { items } = await await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'sales',
        include: 10,
      });

      const data = items[0].fields.pageContent;
      const metadata = items[0].fields.seoMetadata[0].fields;

      const sales = { ...metadata };

      const [hero, form, supportCard, carousel, ...FAQ] = data;

      sales.components = [];
      //  Hero
      sales.components.push({
        name: hero.fields.componentName,
        data: {
          title: hero.fields.title,
          subtitle: hero.fields.description,
        },
      });

      //  Form
      sales.components.push({
        name: 'sales-form',
        data: {
          form: {
            form_id: form.fields.formId,
            form_header: '',
            datalayer: form.fields.formDataLayer,
            form_required_text: form.fields.requiredFieldsText,
          },
          card: {
            title: supportCard.fields.title,
            description: supportCard.fields.description,
            link: {
              text: 'Contact Support',
              href: supportCard.fields.cardLink,
              ga_name: 'Support',
              ga_location: 'body',
            },
          },
          quotes_carousel: {
            quotes: carousel.fields.card.map((card: any) => ({
              title_img: {
                url: card.fields.image.fields.file.url,
                alt: card.fields.image.fields.title,
              },
              quote: card.fields.description,
              author: card.fields.title,
              url: card.fields.cardLink,
              data_ga_name: `${card.fields.title} quote`,
              data_ga_location: 'body',
            })),
          },
        },
      });

      sales.faq = {
        header: 'Frequently asked questions',
        groups: FAQ.map((block: any) => ({
          header: block.fields.title,
          questions: block.fields.singleAccordionGroupItems.map(
            (item: any) => ({
              question: item.fields.header,
              answer: item.fields.text,
            }),
          ),
        })),
      };

      return { sales };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).sales,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <section>
    <component
      :is="component.name"
      v-for="(component, index) in sales.components"
      :key="component.name + `-${index}`"
      :data="component.data"
    />
    <section class="slp-bg-surface-800">
      <faq :data="sales.faq" />
    </section>
    <SlpContainer variant="gradient">
      <NextStep :variant="2" :custom-body="sales.next_step" />
    </SlpContainer>
  </section>
</template>
